test-lib: refactor $GIT_SKIP_TESTS matching
[git/git.git] / t / test-lib.sh
CommitLineData
e1970ce4
JH
1#!/bin/sh
2#
3# Copyright (c) 2005 Junio C Hamano
4#
64b90323
MS
5# This program is free software: you can redistribute it and/or modify
6# it under the terms of the GNU General Public License as published by
7# the Free Software Foundation, either version 2 of the License, or
8# (at your option) any later version.
9#
10# This program is distributed in the hope that it will be useful,
11# but WITHOUT ANY WARRANTY; without even the implied warranty of
12# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
13# GNU General Public License for more details.
14#
15# You should have received a copy of the GNU General Public License
16# along with this program. If not, see http://www.gnu.org/licenses/ .
e1970ce4 17
c2116a17
JH
18# Keep the original TERM for say_color
19ORIGINAL_TERM=$TERM
20
3c8f12c9
JH
21# Test the binaries we have just built. The tests are kept in
22# t/ subdirectory and are run in 'trash directory' subdirectory.
23if test -z "$TEST_DIRECTORY"
24then
25 # We allow tests to override this, in case they want to run tests
26 # outside of t/, e.g. for running tests on the test library
27 # itself.
28 TEST_DIRECTORY=$(pwd)
29fi
30if test -z "$TEST_OUTPUT_DIRECTORY"
31then
32 # Similarly, override this to store the test-results subdir
33 # elsewhere
34 TEST_OUTPUT_DIRECTORY=$TEST_DIRECTORY
35fi
36GIT_BUILD_DIR="$TEST_DIRECTORY"/..
37
2006f0ad
RR
38################################################################
39# It appears that people try to run tests without building...
40"$GIT_BUILD_DIR/git" >/dev/null
41if test $? != 1
42then
43 echo >&2 'error: you do not seem to have built git yet.'
44 exit 1
45fi
46
3c8f12c9
JH
47. "$GIT_BUILD_DIR"/GIT-BUILD-OPTIONS
48export PERL_PATH SHELL_PATH
49
4cde519f
RR
50# if --tee was passed, write the output not only to the terminal, but
51# additionally to the file test-results/$BASENAME.out, too.
52case "$GIT_TEST_TEE_STARTED, $* " in
53done,*)
54 # do not redirect again
55 ;;
56*' --tee '*|*' --va'*)
57 mkdir -p test-results
58 BASE=test-results/$(basename "$0" .sh)
59 (GIT_TEST_TEE_STARTED=done ${SHELL_PATH} "$0" "$@" 2>&1;
60 echo $? > $BASE.exit) | tee $BASE.out
61 test "$(cat $BASE.exit)" = 0
62 exit
63 ;;
64esac
65
e1970ce4
JH
66# For repeatability, reset the environment to known value.
67LANG=C
899460f3 68LC_ALL=C
d9bdd39e 69PAGER=cat
e1970ce4 70TZ=UTC
c2116a17
JH
71TERM=dumb
72export LANG LC_ALL PAGER TERM TZ
8ff99e74 73EDITOR=:
661bfd13
SL
74# A call to "unset" with no arguments causes at least Solaris 10
75# /usr/xpg4/bin/sh and /bin/ksh to bail out. So keep the unsets
76# deriving from the command substitution clustered with the other
77# ones.
3c8f12c9 78unset VISUAL EMAIL LANGUAGE COLUMNS $("$PERL_PATH" -e '
95a1d12e 79 my @env = keys %ENV;
730477f1
JL
80 my $ok = join("|", qw(
81 TRACE
82 DEBUG
83 USE_LOOKUP
84 TEST
85 .*_TEST
86 PROVE
87 VALGRIND
ac001282 88 UNZIP
edb54081 89 PERF_
730477f1
JL
90 ));
91 my @vars = grep(/^GIT_/ && !/^GIT_($ok)/o, @env);
95a1d12e
JN
92 print join("\n", @vars);
93')
5adf84eb 94unset XDG_CONFIG_HOME
29e55cd5
JH
95GIT_AUTHOR_EMAIL=author@example.com
96GIT_AUTHOR_NAME='A U Thor'
29e55cd5
JH
97GIT_COMMITTER_EMAIL=committer@example.com
98GIT_COMMITTER_NAME='C O Mitter'
8d0fc48f 99GIT_MERGE_VERBOSITY=5
f8246281
JH
100GIT_MERGE_AUTOEDIT=no
101export GIT_MERGE_VERBOSITY GIT_MERGE_AUTOEDIT
29e55cd5
JH
102export GIT_AUTHOR_EMAIL GIT_AUTHOR_NAME
103export GIT_COMMITTER_EMAIL GIT_COMMITTER_NAME
d33738d7 104export EDITOR
e1970ce4 105
a731fa91
EP
106# Add libc MALLOC and MALLOC_PERTURB test
107# only if we are not executing the test with valgrind
1b3185fc 108if expr " $GIT_TEST_OPTS " : ".* --valgrind " >/dev/null ||
ee1431bf 109 test -n "$TEST_NO_MALLOC_CHECK"
1b3185fc
JH
110then
111 setup_malloc_check () {
112 : nothing
113 }
114 teardown_malloc_check () {
115 : nothing
116 }
117else
118 setup_malloc_check () {
119 MALLOC_CHECK_=3 MALLOC_PERTURB_=165
120 export MALLOC_CHECK_ MALLOC_PERTURB_
121 }
122 teardown_malloc_check () {
123 unset MALLOC_CHECK_ MALLOC_PERTURB_
124 }
125fi
a731fa91 126
886a3907
JH
127# Protect ourselves from common misconfiguration to export
128# CDPATH into the environment
129unset CDPATH
130
5565f47c 131unset GREP_OPTIONS
ac001282 132unset UNZIP
5565f47c 133
3d5c0cc9 134case $(echo $GIT_TRACE |tr "[A-Z]" "[a-z]") in
1c0cc756
RJ
1351|2|true)
136 echo "* warning: Some tests will not work if GIT_TRACE" \
137 "is set as to trace on STDERR ! *"
138 echo "* warning: Please set GIT_TRACE to something" \
139 "other than 1, 2 or true ! *"
140 ;;
6ce4e61f
CC
141esac
142
cd3c095c
JH
143# Convenience
144#
145# A regexp to match 5 and 40 hexdigits
146_x05='[0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
147_x40="$_x05$_x05$_x05$_x05$_x05$_x05$_x05$_x05"
148
3749fde5
JH
149# Zero SHA-1
150_z40=0000000000000000000000000000000000000000
151
3f4ab627
JH
152# Line feed
153LF='
154'
155
342e9ef2
TR
156export _x05 _x40 _z40 LF
157
e1970ce4
JH
158# Each test should start with something like this, after copyright notices:
159#
160# test_description='Description of this test...
161# This test checks if command xyzzy does the right thing...
162# '
163# . ./test-lib.sh
c2116a17
JH
164[ "x$ORIGINAL_TERM" != "xdumb" ] && (
165 TERM=$ORIGINAL_TERM &&
166 export TERM &&
167 [ -t 1 ] &&
168 tput bold >/dev/null 2>&1 &&
169 tput setaf 1 >/dev/null 2>&1 &&
170 tput sgr0 >/dev/null 2>&1
171 ) &&
55db1df0 172 color=t
e1970ce4 173
e1970ce4
JH
174while test "$#" -ne 0
175do
176 case "$1" in
177 -d|--d|--de|--deb|--debu|--debug)
178 debug=t; shift ;;
886856ab
JH
179 -i|--i|--im|--imm|--imme|--immed|--immedi|--immedia|--immediat|--immediate)
180 immediate=t; shift ;;
5e2c08c6 181 -l|--l|--lo|--lon|--long|--long-|--long-t|--long-te|--long-tes|--long-test|--long-tests)
91e80b98 182 GIT_TEST_LONG=t; export GIT_TEST_LONG; shift ;;
e1970ce4 183 -h|--h|--he|--hel|--help)
570f3226 184 help=t; shift ;;
e1970ce4
JH
185 -v|--v|--ve|--ver|--verb|--verbo|--verbos|--verbose)
186 verbose=t; shift ;;
1ece1274 187 -q|--q|--qu|--qui|--quie|--quiet)
092c4334
ÆAB
188 # Ignore --quiet under a TAP::Harness. Saying how many tests
189 # passed without the ok/not ok details is always an error.
190 test -z "$HARNESS_ACTIVE" && quiet=t; shift ;;
e4597aae
MO
191 --with-dashes)
192 with_dashes=t; shift ;;
55db1df0 193 --no-color)
faa4bc35 194 color=; shift ;;
4e1be63c 195 --va|--val|--valg|--valgr|--valgri|--valgrin|--valgrind)
952af351
TR
196 valgrind=memcheck
197 shift ;;
198 --valgrind=*)
199 valgrind=$(expr "z$1" : 'z[^=]*=\(.*\)')
200 shift ;;
44138559
JS
201 --tee)
202 shift ;; # was handled already
f423ef5f
JK
203 --root=*)
204 root=$(expr "z$1" : 'z[^=]*=\(.*\)')
205 shift ;;
e1970ce4 206 *)
1f729dca 207 echo "error: unknown test option '$1'" >&2; exit 1 ;;
e1970ce4
JH
208 esac
209done
210
952af351
TR
211test -n "$valgrind" && verbose=t
212
1c0cc756
RJ
213if test -n "$color"
214then
55db1df0 215 say_color () {
c2116a17
JH
216 (
217 TERM=$ORIGINAL_TERM
218 export TERM
55db1df0 219 case "$1" in
1c0cc756
RJ
220 error)
221 tput bold; tput setaf 1;; # bold red
222 skip)
b8fc855a 223 tput setaf 4;; # blue
e8e51955
AS
224 warn)
225 tput setaf 3;; # brown/yellow
1c0cc756 226 pass)
0a6d4751 227 tput setaf 2;; # green
1c0cc756 228 info)
0a6d4751 229 tput setaf 6;; # cyan
1c0cc756
RJ
230 *)
231 test -n "$quiet" && return;;
55db1df0
PH
232 esac
233 shift
5099b99d 234 printf "%s" "$*"
55db1df0 235 tput sgr0
b8eecafd 236 echo
c2116a17 237 )
55db1df0
PH
238 }
239else
240 say_color() {
1ece1274 241 test -z "$1" && test -n "$quiet" && return
55db1df0 242 shift
7bc0911d 243 printf "%s\n" "$*"
55db1df0
PH
244 }
245fi
246
247error () {
248 say_color error "error: $*"
6e7b5aaf 249 GIT_EXIT_OK=t
55db1df0
PH
250 exit 1
251}
252
253say () {
254 say_color info "$*"
255}
256
570f3226
MB
257test "${test_description}" != "" ||
258error "Test script did not set test_description."
259
260if test "$help" = "t"
261then
262 echo "$test_description"
263 exit 0
264fi
265
4d9d62fa 266exec 5>&1
781f76b1 267exec 6<&0
e1970ce4
JH
268if test "$verbose" = "t"
269then
270 exec 4>&2 3>&1
271else
272 exec 4>/dev/null 3>/dev/null
273fi
274
275test_failure=0
276test_count=0
41ac414e
JH
277test_fixed=0
278test_broken=0
2d84e9fb 279test_success=0
e1970ce4 280
d998bd4a
ÆAB
281test_external_has_tap=0
282
faa4bc35 283die () {
6e7b5aaf
CB
284 code=$?
285 if test -n "$GIT_EXIT_OK"
286 then
287 exit $code
288 else
289 echo >&5 "FATAL: Unexpected exit with code $code"
290 exit 1
291 fi
faa4bc35
CB
292}
293
6e7b5aaf 294GIT_EXIT_OK=
35641310 295trap 'die' EXIT
41184273 296
12a29b1a
TR
297# The user-facing functions are loaded from a separate file so that
298# test_perf subshells can have them too
3c8f12c9 299. "$TEST_DIRECTORY/test-lib-functions.sh"
05236a5e 300
886856ab
JH
301# You are not expected to call test_ok_ and test_failure_ directly, use
302# the text_expect_* functions instead.
303
304test_ok_ () {
d5d9de1b 305 test_success=$(($test_success + 1))
5099b99d 306 say_color "" "ok $test_count - $@"
e1970ce4
JH
307}
308
886856ab 309test_failure_ () {
d5d9de1b 310 test_failure=$(($test_failure + 1))
5e5c006e 311 say_color error "not ok $test_count - $1"
bf0dd8a8 312 shift
5099b99d 313 echo "$@" | sed -e 's/^/# /'
6e7b5aaf 314 test "$immediate" = "" || { GIT_EXIT_OK=t; exit 1; }
886856ab
JH
315}
316
41ac414e 317test_known_broken_ok_ () {
41ac414e 318 test_fixed=$(($test_fixed+1))
b73d9a23 319 say_color error "ok $test_count - $@ # TODO known breakage vanished"
41ac414e
JH
320}
321
322test_known_broken_failure_ () {
41ac414e 323 test_broken=$(($test_broken+1))
e8e51955 324 say_color warn "not ok $test_count - $@ # TODO known breakage"
41ac414e 325}
886856ab
JH
326
327test_debug () {
8e832ebc 328 test "$debug" = "" || eval "$1"
e1970ce4
JH
329}
330
e6a6ddc9
TR
331match_pattern_list () {
332 arg="$1"
333 shift
334 test -z "$*" && return 1
335 for pattern_
336 do
337 case "$arg" in
338 $pattern_)
339 return 0
340 esac
341 done
342 return 1
343}
344
a7c58f28
JN
345test_eval_ () {
346 # This is a separate function because some tests use
347 # "return" to end a test_expect_success block early.
781f76b1 348 eval </dev/null >&3 2>&4 "$*"
a7c58f28
JN
349}
350
4d9d62fa 351test_run_ () {
b6b0afdc 352 test_cleanup=:
b586744a 353 expecting_failure=$2
a57397b0 354 setup_malloc_check
a7c58f28 355 test_eval_ "$1"
b6b0afdc 356 eval_ret=$?
a57397b0 357 teardown_malloc_check
b586744a
JH
358
359 if test -z "$immediate" || test $eval_ret = 0 || test -n "$expecting_failure"
360 then
1b3185fc 361 setup_malloc_check
a7c58f28 362 test_eval_ "$test_cleanup"
1b3185fc 363 teardown_malloc_check
b586744a 364 fi
1c0cc756
RJ
365 if test "$verbose" = "t" && test -n "$HARNESS_ACTIVE"
366 then
57e1538a
ÆAB
367 echo ""
368 fi
aa0bcf96 369 return "$eval_ret"
4d9d62fa
PR
370}
371
04ece593 372test_skip () {
8586f98b 373 test_count=$(($test_count+1))
04ece593 374 to_skip=
e6a6ddc9
TR
375 if match_pattern_list $this_test.$test_count $GIT_SKIP_TESTS
376 then
377 to_skip=t
378 fi
05236a5e
JN
379 if test -z "$to_skip" && test -n "$test_prereq" &&
380 ! test_have_prereq "$test_prereq"
a7bb3940
JS
381 then
382 to_skip=t
383 fi
04ece593
JH
384 case "$to_skip" in
385 t)
07431fc8 386 of_prereq=
05236a5e 387 if test "$missing_prereq" != "$test_prereq"
07431fc8 388 then
05236a5e 389 of_prereq=" of $test_prereq"
07431fc8
JN
390 fi
391
55db1df0 392 say_color skip >&3 "skipping test: $@"
07431fc8 393 say_color skip "ok $test_count # skip $1 (missing $missing_prereq${of_prereq})"
04ece593
JH
394 : true
395 ;;
396 *)
397 false
398 ;;
399 esac
400}
401
342e9ef2
TR
402# stub; perf-lib overrides it
403test_at_end_hook_ () {
404 :
405}
406
e1970ce4 407test_done () {
6e7b5aaf 408 GIT_EXIT_OK=t
2d84e9fb 409
1c0cc756
RJ
410 if test -z "$HARNESS_ACTIVE"
411 then
342e9ef2 412 test_results_dir="$TEST_OUTPUT_DIRECTORY/test-results"
8ef1abe5 413 mkdir -p "$test_results_dir"
dd78478f
FC
414 base=${0##*/}
415 test_results_path="$test_results_dir/${base%.sh}-$$.counts"
8ef1abe5 416
c54e6be7
ML
417 cat >>"$test_results_path" <<-EOF
418 total $test_count
419 success $test_success
420 fixed $test_fixed
421 broken $test_broken
422 failed $test_failure
423
424 EOF
8ef1abe5 425 fi
41ac414e
JH
426
427 if test "$test_fixed" != 0
428 then
b73d9a23 429 say_color error "# $test_fixed known breakage(s) vanished; please update test(s)"
41ac414e
JH
430 fi
431 if test "$test_broken" != 0
432 then
e8e51955 433 say_color warn "# still have $test_broken known breakage(s)"
b73d9a23
AS
434 fi
435 if test "$test_broken" != 0 || test "$test_fixed" != 0
436 then
437 test_remaining=$(( $test_count - $test_broken - $test_fixed ))
438 msg="remaining $test_remaining test(s)"
11d54b8b 439 else
b73d9a23 440 test_remaining=$test_count
11d54b8b 441 msg="$test_count test(s)"
41ac414e 442 fi
e1970ce4 443 case "$test_failure" in
10b94e28 444 0)
5099b99d 445 # Maybe print SKIP message
bf4b7219
RJ
446 if test -n "$skip_all" && test $test_count -gt 0
447 then
448 error "Can't use skip_all after running some tests"
449 fi
5099b99d
ÆAB
450 [ -z "$skip_all" ] || skip_all=" # SKIP $skip_all"
451
1c0cc756
RJ
452 if test $test_external_has_tap -eq 0
453 then
b73d9a23 454 if test $test_remaining -gt 0
d87bd7c1
RJ
455 then
456 say_color pass "# passed all $msg"
457 fi
d998bd4a
ÆAB
458 say "1..$test_count$skip_all"
459 fi
abc5d372
JS
460
461 test -d "$remove_trash" &&
462 cd "$(dirname "$remove_trash")" &&
463 rm -rf "$(basename "$remove_trash")"
464
342e9ef2
TR
465 test_at_end_hook_
466
e1970ce4
JH
467 exit 0 ;;
468
469 *)
1c0cc756
RJ
470 if test $test_external_has_tap -eq 0
471 then
d998bd4a
ÆAB
472 say_color error "# failed $test_failure among $msg"
473 say "1..$test_count"
474 fi
5099b99d 475
e1970ce4
JH
476 exit 1 ;;
477
478 esac
479}
480
e4597aae 481if test -n "$valgrind"
4e1be63c 482then
4e1be63c
JS
483 make_symlink () {
484 test -h "$2" &&
485 test "$1" = "$(readlink "$2")" || {
486 # be super paranoid
487 if mkdir "$2".lock
488 then
489 rm -f "$2" &&
490 ln -s "$1" "$2" &&
491 rm -r "$2".lock
492 else
493 while test -d "$2".lock
494 do
495 say "Waiting for lock on $2."
496 sleep 1
497 done
498 fi
499 }
500 }
501
502 make_valgrind_symlink () {
36bfb0e5
JK
503 # handle only executables, unless they are shell libraries that
504 # need to be in the exec-path. We will just use "#!" as a
505 # guess for a shell-script, since we have no idea what the user
506 # may have configured as the shell path.
507 test -x "$1" ||
508 test "#!" = "$(head -c 2 <"$1")" ||
509 return;
4e1be63c
JS
510
511 base=$(basename "$1")
6cec5c68 512 symlink_target=$GIT_BUILD_DIR/$base
4e1be63c
JS
513 # do not override scripts
514 if test -x "$symlink_target" &&
515 test ! -d "$symlink_target" &&
516 test "#!" != "$(head -c 2 < "$symlink_target")"
517 then
518 symlink_target=../valgrind.sh
519 fi
efd92ffd
JS
520 case "$base" in
521 *.sh|*.perl)
522 symlink_target=../unprocessed-script
523 esac
4e1be63c
JS
524 # create the link, or replace it if it is out of date
525 make_symlink "$symlink_target" "$GIT_VALGRIND/bin/$base" || exit
526 }
527
528 # override all git executables in TEST_DIRECTORY/..
529 GIT_VALGRIND=$TEST_DIRECTORY/valgrind
530 mkdir -p "$GIT_VALGRIND"/bin
6cec5c68 531 for file in $GIT_BUILD_DIR/git* $GIT_BUILD_DIR/test-*
4e1be63c
JS
532 do
533 make_valgrind_symlink $file
534 done
ee0d7bf9
TR
535 # special-case the mergetools loadables
536 make_symlink "$GIT_BUILD_DIR"/mergetools "$GIT_VALGRIND/bin/mergetools"
efd92ffd
JS
537 OLDIFS=$IFS
538 IFS=:
539 for path in $PATH
540 do
541 ls "$path"/git-* 2> /dev/null |
542 while read file
543 do
544 make_valgrind_symlink "$file"
545 done
546 done
547 IFS=$OLDIFS
4e1be63c
JS
548 PATH=$GIT_VALGRIND/bin:$PATH
549 GIT_EXEC_PATH=$GIT_VALGRIND/bin
550 export GIT_VALGRIND
952af351
TR
551 GIT_VALGRIND_MODE="$valgrind"
552 export GIT_VALGRIND_MODE
1c0cc756
RJ
553elif test -n "$GIT_TEST_INSTALLED"
554then
e4597aae
MO
555 GIT_EXEC_PATH=$($GIT_TEST_INSTALLED/git --exec-path) ||
556 error "Cannot run git from $GIT_TEST_INSTALLED."
6cec5c68 557 PATH=$GIT_TEST_INSTALLED:$GIT_BUILD_DIR:$PATH
e4597aae
MO
558 GIT_EXEC_PATH=${GIT_TEST_EXEC_PATH:-$GIT_EXEC_PATH}
559else # normal case, use ../bin-wrappers only unless $with_dashes:
6cec5c68 560 git_bin_dir="$GIT_BUILD_DIR/bin-wrappers"
1c0cc756
RJ
561 if ! test -x "$git_bin_dir/git"
562 then
563 if test -z "$with_dashes"
564 then
e4597aae
MO
565 say "$git_bin_dir/git is not executable; using GIT_EXEC_PATH"
566 fi
567 with_dashes=t
568 fi
569 PATH="$git_bin_dir:$PATH"
6cec5c68 570 GIT_EXEC_PATH=$GIT_BUILD_DIR
1c0cc756
RJ
571 if test -n "$with_dashes"
572 then
6cec5c68 573 PATH="$GIT_BUILD_DIR:$PATH"
e4597aae 574 fi
4e1be63c 575fi
6cec5c68 576GIT_TEMPLATE_DIR="$GIT_BUILD_DIR"/templates/blt
8bfa6bd6 577unset GIT_CONFIG
8bfa6bd6 578GIT_CONFIG_NOSYSTEM=1
3c995beb 579GIT_ATTR_NOSYSTEM=1
8f323c00 580export PATH GIT_EXEC_PATH GIT_TEMPLATE_DIR GIT_CONFIG_NOSYSTEM GIT_ATTR_NOSYSTEM
49ccb087 581
5e87eae9
JH
582if test -z "$GIT_TEST_CMP"
583then
584 if test -n "$GIT_TEST_CMP_USE_COPIED_CONTEXT"
585 then
586 GIT_TEST_CMP="$DIFF -c"
587 else
588 GIT_TEST_CMP="$DIFF -u"
589 fi
590fi
591
6cec5c68 592GITPERLLIB="$GIT_BUILD_DIR"/perl/blib/lib:"$GIT_BUILD_DIR"/perl/blib/arch/auto/Git
6fcca938 593export GITPERLLIB
6cec5c68 594test -d "$GIT_BUILD_DIR"/templates/blt || {
eea42069
JH
595 error "You haven't built things yet, have you?"
596}
e1970ce4 597
ac10a857 598if test -z "$GIT_TEST_INSTALLED" && test -z "$NO_PYTHON"
2fe40b63 599then
6cec5c68 600 GITPYTHONLIB="$GIT_BUILD_DIR/git_remote_helpers/build/lib"
2fe40b63 601 export GITPYTHONLIB
6cec5c68 602 test -d "$GIT_BUILD_DIR"/git_remote_helpers/build || {
2fe40b63
SR
603 error "You haven't built git_remote_helpers yet, have you?"
604 }
605fi
606
1c0cc756
RJ
607if ! test -x "$GIT_BUILD_DIR"/test-chmtime
608then
56cf9806
EW
609 echo >&2 'You need to build test-chmtime:'
610 echo >&2 'Run "make test-chmtime" in the source (toplevel) directory'
611 exit 1
612fi
613
e1970ce4 614# Test repository
002d4ce8
JK
615TRASH_DIRECTORY="trash directory.$(basename "$0" .sh)"
616test -n "$root" && TRASH_DIRECTORY="$root/$TRASH_DIRECTORY"
617case "$TRASH_DIRECTORY" in
618/*) ;; # absolute path is good
619 *) TRASH_DIRECTORY="$TEST_OUTPUT_DIRECTORY/$TRASH_DIRECTORY" ;;
f423ef5f 620esac
91c8b825 621test ! -z "$debug" || remove_trash=$TRASH_DIRECTORY
38b074de 622rm -fr "$TRASH_DIRECTORY" || {
6e7b5aaf 623 GIT_EXIT_OK=t
8d14ac94
JH
624 echo >&5 "FATAL: Cannot prepare test area"
625 exit 1
626}
627
90cff968
AR
628HOME="$TRASH_DIRECTORY"
629export HOME
630
1c0cc756
RJ
631if test -z "$TEST_NO_CREATE_REPO"
632then
38b074de 633 test_create_repo "$TRASH_DIRECTORY"
342e9ef2 634else
38b074de 635 mkdir -p "$TRASH_DIRECTORY"
342e9ef2 636fi
1bd9c648
LW
637# Use -P to resolve symlinks in our working directory so that the cwd
638# in subprocesses like git equals our $PWD (for pathname comparisons).
38b074de 639cd -P "$TRASH_DIRECTORY" || exit 1
04ece593 640
d5d9de1b
JS
641this_test=${0##*/}
642this_test=${this_test%%-*}
e6a6ddc9
TR
643if match_pattern_list "$this_test" $GIT_SKIP_TESTS
644then
645 say_color info >&3 "skipping test $this_test altogether"
646 skip_all="skip all tests in $this_test"
647 test_done
648fi
f17e9fbb 649
8648732e
BC
650# Provide an implementation of the 'yes' utility
651yes () {
652 if test $# = 0
653 then
654 y=y
655 else
656 y="$*"
657 fi
658
659 while echo "$y"
660 do
661 :
662 done
663}
664
f17e9fbb
JS
665# Fix some commands on Windows
666case $(uname -s) in
667*MINGW*)
668 # Windows has its own (incompatible) sort and find
669 sort () {
670 /usr/bin/sort "$@"
671 }
672 find () {
673 /usr/bin/find "$@"
674 }
5397ea31
JS
675 sum () {
676 md5sum "$@"
677 }
4114156a
JS
678 # git sees Windows-style pwd
679 pwd () {
680 builtin pwd -W
681 }
ee9fb68c 682 # no POSIX permissions
6fd1106a 683 # backslashes in pathspec are converted to '/'
fb9a2bea 684 # exec does not inherit the PID
a94114ad 685 test_set_prereq MINGW
cfa96496 686 test_set_prereq NOT_CYGWIN
a31d0665
RJ
687 test_set_prereq SED_STRIPS_CR
688 ;;
689*CYGWIN*)
690 test_set_prereq POSIXPERM
a31d0665
RJ
691 test_set_prereq EXECKEEPSPID
692 test_set_prereq NOT_MINGW
cfa96496 693 test_set_prereq CYGWIN
a31d0665 694 test_set_prereq SED_STRIPS_CR
ee9fb68c
JS
695 ;;
696*)
697 test_set_prereq POSIXPERM
6fd1106a 698 test_set_prereq BSLASHPSPEC
fb9a2bea 699 test_set_prereq EXECKEEPSPID
3ba9ba8f 700 test_set_prereq NOT_MINGW
cfa96496 701 test_set_prereq NOT_CYGWIN
f17e9fbb
JS
702 ;;
703esac
704a3143 704
b082687c 705( COLUMNS=1 && test $COLUMNS = 1 ) && test_set_prereq COLUMNS_CAN_BE_1
1b19ccd2 706test -z "$NO_PERL" && test_set_prereq PERL
d4e1b47a 707test -z "$NO_PYTHON" && test_set_prereq PYTHON
8f852ce6 708test -n "$USE_LIBPCRE" && test_set_prereq LIBPCRE
5e9637c6 709test -z "$NO_GETTEXT" && test_set_prereq GETTEXT
1b19ccd2 710
bb946bba 711# Can we rely on git's output in the C locale?
30955229
JN
712if test -n "$GETTEXT_POISON"
713then
714 GIT_GETTEXT_POISON=YesPlease
715 export GIT_GETTEXT_POISON
5e9637c6 716 test_set_prereq GETTEXT_POISON
30955229
JN
717else
718 test_set_prereq C_LOCALE_OUTPUT
719fi
bb946bba 720
cabdee2c
JH
721# Use this instead of test_cmp to compare files that contain expected and
722# actual output from git commands that can be translated. When running
723# under GETTEXT_POISON this pretends that the command produced expected
724# results.
725test_i18ncmp () {
726 test -n "$GETTEXT_POISON" || test_cmp "$@"
727}
728
127df8c6
JH
729# Use this instead of "grep expected-string actual" to see if the
730# output from a git command that can be translated either contains an
731# expected string, or does not contain an unwanted one. When running
732# under GETTEXT_POISON this pretends that the command produced expected
733# results.
734test_i18ngrep () {
735 if test -n "$GETTEXT_POISON"
736 then
737 : # pretend success
738 elif test "x!" = "x$1"
739 then
740 shift
741 ! grep "$@"
742 else
743 grep "$@"
744 fi
745}
746
20073274
AS
747test_lazy_prereq PIPE '
748 # test whether the filesystem supports FIFOs
749 rm -f testfifo && mkfifo testfifo
750'
751
04083f27
JH
752test_lazy_prereq SYMLINKS '
753 # test whether the filesystem supports symbolic links
754 ln -s x y && test -h y
755'
c91cfd19 756
ac39aa61
MG
757test_lazy_prereq CASE_INSENSITIVE_FS '
758 echo good >CamelCase &&
759 echo bad >camelcase &&
760 test "$(cat CamelCase)" != good
761'
762
5b0b5dd4
MG
763test_lazy_prereq UTF8_NFD_TO_NFC '
764 # check whether FS converts nfd unicode to nfc
765 auml=$(printf "\303\244")
766 aumlcdiar=$(printf "\141\314\210")
767 >"$auml" &&
768 case "$(echo *)" in
769 "$aumlcdiar")
770 true ;;
771 *)
772 false ;;
773 esac
774'
775
09feffb6
JK
776test_lazy_prereq AUTOIDENT '
777 sane_unset GIT_AUTHOR_NAME &&
778 sane_unset GIT_AUTHOR_EMAIL &&
779 git var GIT_AUTHOR_IDENT
780'
781
c91cfd19
ÆAB
782# When the tests are run as root, permission tests will report that
783# things are writable when they shouldn't be.
784test -w / || test_set_prereq SANITY
f838ce58
JK
785
786GIT_UNZIP=${GIT_UNZIP:-unzip}
787test_lazy_prereq UNZIP '
788 "$GIT_UNZIP" -v
789 test $? -ne 127
790'